#ifndef __DEPEND_FUNCTION__
#define __DEPEND_FUNCTION__

#include <RcppArmadillo.h>
double loglik_cpp(arma::mat A, arma::mat S, arma::mat response);
double neg_loglik_cpp(arma::mat A, arma::mat S, arma::mat response);

double loglik_cpp1(arma::mat A, arma::mat S,arma::mat beta, arma::mat Z, arma::mat response);
double neg_loglik_cpp1(arma::mat A, arma::mat S,arma::mat beta, arma::mat Z, arma::mat response);

double loglik_IRT_cpp(arma::mat A, arma::vec S, arma::mat response);

double obj_cpp(arma::mat A, arma::mat S, arma::mat response, double gamma);

arma::mat neg_loglik_dev_cpp(arma::mat L, arma::mat S, arma::mat response);

arma::mat neg_loglik_dev_cpp1(arma::mat L, arma::mat S, arma::mat beta,arma::mat Z, arma::mat response);

arma::mat grad_A_cpp(arma::mat A0, arma::mat S0, arma::mat Q, arma::mat response);
arma::mat grad_A_cpp1(arma::mat A0, arma::mat S0, arma::mat Q, arma::mat beta,arma::mat Z, arma::mat response);

Rcpp::List Update_A_cpp(arma::mat A0, arma::mat S0, arma::mat Q, arma::mat response,double step , double disc );

arma::mat grad_S_cpp(arma::mat A0, arma::mat S0, arma::mat response);

arma::mat grad_S_cpp1(arma::mat A0, arma::mat S0, arma::mat beta,arma::mat Z, arma::mat response);

arma::mat grad_beta_cpp1(arma::mat A, arma::mat S, arma::mat beta, arma::mat Z, arma::mat response);

double pos_cpp(double x);


arma::vec pos_v_cpp(arma::vec x);

arma::mat soft_thre_cpp(arma::mat x, double mu);

double fhat_cpp(arma::mat S, arma::mat S0, arma::mat A0, arma::mat response, double step);

Rcpp::List Update_S_cpp(arma::mat A0, arma::mat S0, double gamma, arma::mat response,
                       double step, double disc );

Rcpp::List tt(arma::mat m, double s);

arma::mat grad_S_supp_cpp(arma::mat A0, arma::mat S0, arma::mat supp, arma::mat response);
arma::mat grad_S_supp_cpp22(arma::mat A0, arma::mat S0, arma::mat B0, arma::mat supp, arma::mat response);

Rcpp::List Update_S_supp_cpp(arma::mat A0, arma::mat S0, arma::mat supp, arma::mat response,
                             double step , double disc );
Rcpp::List Update_S_supp_cpp22(arma::mat A0, arma::mat S0, arma::mat B0, arma::mat supp, arma::mat response,
                               double step , double disc );
Rcpp::List reparam1(arma::mat A, arma::mat S);
Rcpp::List reparam2(arma::mat A, arma::mat S);

arma::mat calcu_2dev_cpp(arma::mat A, arma::vec b,arma::mat beta, arma::vec x,arma::vec Z);
arma::mat calcu_2dev_cov_cpp(arma::mat A, arma::vec b,arma::mat beta, arma::vec x,arma::vec Z);

double neg_loglik_cpp22(arma::mat A, arma::mat S, arma::mat B, arma::mat response);

arma::mat grad_A_cpp22(arma::mat A0, arma::mat S0, arma::mat B0, arma::mat Q, arma::mat response);

arma::mat grad_S_cpp22(arma::mat A0, arma::mat S0, arma::mat B0, arma::mat response);

arma::mat grad_B_cpp22(arma::mat A0, arma::mat S0, arma::mat B0, arma::mat response);


#endif

