#include <RcppArmadillo.h>
#include <Rcpp.h>
#include "depend_functions.h"
// [[Rcpp::depends(RcppArmadillo)]]
//' @useDynLib flagr
// [[Rcpp::export]]
arma::mat FLaG_sample(arma::mat A, arma::mat S, arma::mat Sigma, int N, int burn) {
  int J = A.n_rows;
  double temp=0;
  double prob=0;
  arma::mat response = arma::zeros(N, J);
  arma::mat LS = A * Sigma * A.t() + S;
  arma::vec resp(J);

  for(int i = 0; i < N; ++i){
    resp = Rcpp::rbinom(J, 1, 0.5);
    for(int z=0; z < burn; ++z){
      for(int j=0; j < J; ++j){
        temp = LS(j, j)/2;
        for(int k=0;k<J;++k){
          if(k != j)
            temp += LS(j,k) * resp(k);
        }
        prob = exp(temp)/(1 + exp(temp));
        resp(j) = Rcpp::rbinom(1,1,prob)(0);
      }
    }
    for(int p=0;p<J;++p)
      response(i,p) = resp(p);
  }
  return response;
}
